// This class was created by JaTiTV.

package net.t2code.t2codelib.SPIGOT.newLanguageFileBuilder;


import net.t2code.t2codelib.SPIGOT.system.T2CodeLibMain;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2CLibConfig;
import net.t2code.t2codelib.Util;

import java.util.*;

public class Languages {


    public enum VALUES implements T2CconfigItemLanguages {


        vaultNotSetUp("Plugin.VaultNotSetUp",
                null,
                List.of(
                        new T2ClanguageObject("english", "[prefix] &4Vault / Economy not set up!"),
                        new T2ClanguageObject("german", "[prefix] &4Vault / Economy nicht eingerichtet!"))
                , "comment 1"),

        votingPluginNotSetUp("Plugin.VotingPluginNotSetUp",
                null,
                List.of(new T2ClanguageObject("english", "[prefix] &4VotingPlugin is not present on the server!"),
                        new T2ClanguageObject("german", "[prefix] &4VotingPlugin ist auf dem Server nicht vorhanden!"))
                , "comment 2"),
        soundNotFound("Plugin.SoundNotFound",
                null,
                List.of(new T2ClanguageObject("english", "[prefix] &4The sound &6[sound] &4was not found! Please check the settings."),
                        new T2ClanguageObject("german", "[prefix] &4Der Sound &6[sound] &4wurde nicht gefunden! Bitte [ue]berpr[ue]fe die Einstellungen."))
                , "comment 3"),

        ;

        private final String path;
        private Object value;
        private final List<T2ClanguageObject> lang;

        private final List<String> comments;

        VALUES(String path, Object value, List<T2ClanguageObject> lang, String... comments) {
            this.path = path;
            this.value = value;
            this.lang = lang;

            this.comments = new ArrayList<>(Arrays.asList(comments));
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public List<T2ClanguageObject> getLanguage() {
            return lang;
        }

        @Override
        public List<String> getComments() {
            return comments;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set() {
        T2CconfigWriterLanguage.createConfig(T2CodeLibMain.getPath(), Arrays.asList("german", "english"), VALUES.values(), T2CLibConfig.VALUES.language.getValue().toString(), Util.getConfigLogo());

    }
}