// This class was created by JaTiTV.

package net.t2code.t2codelib.SPIGOT.newLanguageFileBuilder;

import net.t2code.t2codelib.SPIGOT.api.debug.T2Cdebug;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Ctemplate;
import net.t2code.t2codelib.SPIGOT.system.T2CodeLibMain;

import net.t2code.t2codelib.Util;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class T2CconfigWriterLanguage {

    private static FileConfiguration config;

    public static void createConfig(File path, List<String> languages, T2CconfigItemLanguages[] values, String loadConfig, String... header) {

        for (String l : languages) {
            File configFile = new File(path, "languages/" + l + ".yml");
            if (!configFile.exists()) {
                configFile.getParentFile().mkdirs();
                try {
                    configFile.createNewFile();
                } catch (IOException e) {
                    e.printStackTrace();
                    return;
                }
            }
            Map<String, List<String>> comments = new LinkedHashMap<>();
            // Copy default values if they are missing
            config = YamlConfiguration.loadConfiguration(configFile);
            config.options().copyDefaults(true);

            for (T2CconfigItemLanguages item : values) {
                for (T2ClanguageObject object : item.getLanguage()) {
                    if (object.getLanguage().equals(l)) {
                        config.addDefault(item.getPath(), object.getText());
                    }
                }
                comments.put(item.getPath(), item.getComments());
            }
            saveConfigWithComments(configFile, comments, header);
        }
        readConfig(values, loadConfig);
    }

    private static void readConfig(T2CconfigItemLanguages[] values, String loadConfig) {
        String selectMSG;
        File msg;
        msg = new File(T2CodeLibMain.getPath(), "languages/" + loadConfig + ".yml");
        if (!msg.isFile()) {
            T2Ctemplate.onStartMsg(Util.getPrefix(), "");
            T2Ctemplate.onStartMsg(Util.getPrefix(), "§4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            T2Ctemplate.onStartMsg(Util.getPrefix(), "§4The selected §c" + loadConfig + " §4language file was not found.");
            T2Ctemplate.onStartMsg(Util.getPrefix(), "§6The default language §eEnglish §6is used!");
            T2Ctemplate.onStartMsg(Util.getPrefix(), "§4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            T2Ctemplate.onStartMsg(Util.getPrefix(), "");
            msg = new File(T2CodeLibMain.getPath(), "languages/" + "english.yml");
            selectMSG = "english";
        } else selectMSG = loadConfig;
        YamlConfiguration yml = YamlConfiguration.loadConfiguration(msg);
        for (T2CconfigItemLanguages value : values) {
            value.setValue(yml.get(value.getPath()));
        }
        T2Ctemplate.onStartMsg(Util.getPrefix(), "§2Language successfully selected to: §6" + selectMSG);
    }

    private static void saveConfigWithComments(File file, Map<String, List<String>> comments, String... headers) {
        try {
            StringBuilder configContent = new StringBuilder();
            for (String h : headers) {
                configContent.append(h).append("\n");
            }
            configContent.append("\n");
            addSection(config, comments, configContent, "", 0);

            // Write the content to the file
            Files.write(file.toPath(), configContent.toString().getBytes());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static void addSection(ConfigurationSection section, Map<String, List<String>> comments, StringBuilder builder, String prefix, int indentLevel) {
        String indent = "  ".repeat(indentLevel);


        for (String key : section.getKeys(false)) {
            String fullKey = prefix.isEmpty() ? key : prefix + "." + key;
            Object value = section.get(key);

            // Add comment if it exists for this key
            List<String> commentList = comments.get(fullKey);
            if (commentList != null) {
                for (String c : commentList) {
                    builder.append(indent).append("# ").append(c).append("\n");
                }
            }

            // Check if the value is a section (nested map)
            if (value instanceof ConfigurationSection) {
                // Correctly add the section
                builder.append(indent).append(key).append(":\n");
                addSection((ConfigurationSection) value, comments, builder, fullKey, indentLevel + 1);
            } else {
                // Add value with proper indentation
                // builder.append(indent).append(key).append(": ").append(value).append("\n");
                if (value instanceof List) {
                    builder.append(indent).append(key).append(": ").append("\n");
                    List<Object> zw = (List<Object>) value;
                    for (Object s : zw) {
                        if (s instanceof String) {
                            builder.append(indent).append("- \"").append(s).append("\"\n");
                        } else builder.append(indent).append("- ").append(s).append("\n");
                    }
                } else {
                    if (value instanceof String) {
                        builder.append(indent).append(key).append(": \"").append(value).append("\"\n");
                    } else builder.append(indent).append(key).append(": ").append(value).append("\n");
                }
            }
        }
    }
}
